precision highp float;
varying highp vec2 vTextureCoord;
uniform sampler2D iChannel0;
uniform float intensity;

const float a = 1.357697966704323E-01;
const float b = 1.006045552016985E+00;
const float c = 4.674339906510876E-01;
const float d = 8.029414702292208E-01;
const float e = 1.127806558508491E-01;

const vec3 luminanceWeighting = vec3(0.3, 0.3, 0.3);
void main()
{
    lowp vec4 color = texture2D(iChannel0, vTextureCoord);
    float highlights = intensity;
    //src.rgb += src.rgb*src.rgb * (highlights * 0.2);
    float maxx = max(color.r, max(color.g, color.b));
    float minx = min(color.r, min(color.g, color.b));
    float lum = (maxx+minx)/2.0;
    float x1 = abs(highlights);
    float x2 = lum;
    float lum_new =  lum < 0.5 ? lum :
    lum + a * sign(highlights)
    * exp(-0.5
    * (((x1-b)/c)*((x1-b)/c) + ((x2-d)/e)*((x2-d)/e)));

    //src = color * lum_new / lum;
    color = vec4(color.rgb * lum_new / lum, color.a);

    //gl_FragColor = color * lum_new / lum;
    gl_FragColor = color;
}