precision highp float;
varying highp vec2 vTextureCoord;
uniform sampler2D iChannel0;
uniform float intensity;// [-1, 1]

void main()
{
    lowp vec4 color = texture2D(iChannel0, vTextureCoord);
    lowp vec3 luminance = vec3( 0.3086, 0.6094, 0.0820 );
    lowp float onePlusSat = intensity + 1.;
    lowp vec3 red = vec3( luminance.x * -intensity );
    red.r += onePlusSat;
    
    lowp vec3 green = vec3( luminance.y * -intensity );
    green.g += onePlusSat;
    
    lowp vec3 blue = vec3( luminance.z * -intensity );
    blue.b += onePlusSat;
    
    gl_FragColor = mat4(red,     0,
                        green,   0,
                        blue,    0,
                        0, 0, 0, 1 ) * color;
}
