precision highp float;
varying highp vec2 vTextureCoord;
uniform sampler2D iChannel0;
uniform float intensity;
const vec3 luminanceWeighting = vec3(0.2, 0.2, 0.2);

void main()
{
    //fix : alpha
    lowp vec4 src = texture2D(iChannel0, vTextureCoord);
    float shadows = intensity;
    vec4 color = src;
    if (shadows < 0.){
        vec3 rgb = 1./src.rgb/24.*abs(shadows);
        color = vec4((src.rgb - rgb), src.a);
    } else {
        float luminance = dot(src.rgb, luminanceWeighting);
        float shadowValue = clamp((pow(luminance, 1.0/(shadows+1.0)) + (-0.76)*pow(luminance, 2.0/(shadows+1.0))) - luminance, 0.0, 1.0);
        vec3 result = vec3(0.0, 0.0, 0.0) + ((luminance + shadowValue) - 0.0) * ((src.rgb - vec3(0.0, 0.0, 0.0))/(luminance - 0.0));
        color = vec4(result, src.a);
    }
    gl_FragColor = color;
}