precision highp float;
varying highp vec2 vTextureCoord;
uniform sampler2D iChannel0;

varying highp vec2 leftTextureCoord;
varying highp vec2 rightTextureCoord;
varying highp vec2 topTextureCoord;
varying highp vec2 bottomTextureCoord;
varying highp float centerMultiplier;
varying highp float edgeMultiplier;

void main()
{
    mediump vec3 textureColor = texture2D(iChannel0, vTextureCoord).rgb;
    mediump vec3 leftTextureColor = texture2D(iChannel0, leftTextureCoord).rgb;
    mediump vec3 rightTextureColor = texture2D(iChannel0, rightTextureCoord).rgb;
    mediump vec3 topTextureColor = texture2D(iChannel0, topTextureCoord).rgb;
    mediump vec3 bottomTextureColor = texture2D(iChannel0, bottomTextureCoord).rgb;

    gl_FragColor = vec4((textureColor * centerMultiplier - (leftTextureColor * edgeMultiplier + rightTextureColor * edgeMultiplier + topTextureColor * edgeMultiplier + bottomTextureColor * edgeMultiplier)), texture2D(iChannel0, bottomTextureCoord).w);
    //gl_FragColor = vec4(1.0);
}


