attribute vec4 aPosition;
attribute vec4 aTextureCoord;
varying vec2 vTextureCoord;

//uniform float imageWidth; // 1.0f / width
//uniform float imageHeight; //1.0f/ height
uniform vec3  iResolution;
uniform float intensity; //from -4.0 to 4.0, with 0.0 as the normal level

varying vec2 leftTextureCoord;
varying vec2 rightTextureCoord;
varying vec2 topTextureCoord;
varying vec2 bottomTextureCoord;

varying float centerMultiplier;
varying float edgeMultiplier;


void main() {
    gl_Position = aPosition;

    mediump vec2 widthStep = vec2(1./iResolution.x, 0.0);
    mediump vec2 heightStep = vec2(0.0, 1./iResolution.y);

    vTextureCoord = aTextureCoord.xy;
    leftTextureCoord = aTextureCoord.xy - widthStep;
    rightTextureCoord = aTextureCoord.xy + widthStep;
    topTextureCoord = aTextureCoord.xy + heightStep;
    bottomTextureCoord = aTextureCoord.xy - heightStep;
    centerMultiplier = 1.0 + 4.0 * intensity;
    edgeMultiplier = 1.0 * intensity ;
}



