precision highp float;
uniform sampler2D iChannel0;
uniform lowp float intensity;//[-1, 1]
varying highp vec2 vTextureCoord;

vec3 vignette(vec3 color, vec2 uv, float adjust) {
    float vignette = abs(adjust);
    if(adjust > 0.0){
        color.rgb += max((distance(uv, vec2(0.5, 0.5)) - 0.25) * 1.25 * vignette, 0.0);
    }else{
        color.rgb -= max((distance(uv, vec2(0.5, 0.5)) - 0.25) * 1.25 * vignette, 0.0);
    }
    return color;
}

void main()
{
    vec2 uv = vTextureCoord;
    vec4 src = texture2D(iChannel0, uv);
    float adjust = intensity;
    vec4 color = vec4(vignette(src.rgb, uv, adjust),src.a);
    gl_FragColor = color;
}