precision highp float;

varying highp vec2 vTextureCoord;
uniform float     iGlobalTime;
uniform sampler2D iChannel0;
uniform sampler2D iChannel1;
uniform float progress;
uniform float flashType;
uniform float flip;

vec3 color = vec3(0.0, 0.0, 0.0);// = vec3(0.0)
const float colorPhase = 0.4;


vec4 getFromColor(vec2 uv) {
    return texture2D(iChannel0, vec2(uv.x, uv.y));
}

vec4 getToColor(vec2 uv) {
    return texture2D(iChannel1, vec2(uv.x, uv.y));
}


vec4 transition (vec2 uv) {
    return mix(
    mix(vec4(color, 1.0), getFromColor(uv), smoothstep(1.0-colorPhase, 0.0, progress)),
    mix(vec4(color, 1.0), getToColor(uv), smoothstep(colorPhase, 1.0, progress)),
    progress);
}

void main() {
    gl_FragColor = transition(vTextureCoord);
}
