precision highp float;

varying highp vec2 vTextureCoord;
uniform sampler2D iChannel0;
uniform sampler2D iChannel1;
uniform float progress;
uniform float direction;

const float zoom_quickness = 0.8; // = 0.8
float nQuick = clamp(zoom_quickness,0.2,1.0);

vec4 getFromColor(vec2 uv) {
    return texture2D(iChannel0, vec2(uv.x,  uv.y));
}

vec4 getToColor(vec2 uv) {
    return texture2D(iChannel1, vec2(uv.x, uv.y));
}

vec2 zoom(vec2 uv, float amount) {
//    if (direction == 1.0) {
//        return 0.5 + ((uv - 0.5) * amount);
//    } else {
        return 0.5 + ((uv - 0.5) * (1.0-amount));
//    }
}

vec4 transition (vec2 uv) {
    return mix(
    getFromColor(zoom(uv, smoothstep(0.0, nQuick, progress))),
    getToColor(uv),
    smoothstep(nQuick-0.2, 1.0, progress)
    );
}

void main() {
    gl_FragColor = transition(vTextureCoord);
}
